// RTOS_1 1st Example of using FreeRTOS
// by Joe Jaworski

//#include <arduino.h>
#include <Arduino_FreeRTOS.h>

const uint8_t LEDPin = 13;                      // Built-in LED I/O Pin

#define rtDelay(v) {vTaskDelay(v/15);}          // delay in milliseconds




// ***************
// setup() function
//
void setup()
{

// Setup our LED Blinky Task
    xTaskCreate
    (
        TaskBlink,                      // function name
        (const portCHAR *)"blink",      // task name
        128,                            // stack size
        NULL,                           // No creation parms
        2,                              // Priority
        NULL                            // returned task handle
    );


// Setup our Serial Comm Task
    xTaskCreate
    (
        TaskComm,                       // function name
        (const portCHAR *)"comm",       // task name
        128,                            // stack size
        NULL,                           // No creation parms
        2,                              // Priority
        NULL                            // returned task handle
    );


} // End Setup




// *****************
// loop() function
//
void loop()
{
    /* Nothing to do here! */

} // End loop()




// **********************
// TaskBlink() function
//
void TaskBlink(void*)
{
    pinMode(LEDPin, OUTPUT);            // Set LED I/O pin to OUTPUT

    for(;;)
    {
        rtDelay(500);
        digitalWrite(LEDPin, HIGH);                // Turn on Led
        rtDelay(500);
        digitalWrite(LEDPin, LOW);                 // Turn off Led

    }
} // End TaskBlink



// **********************
// TaskComm() function
//
void TaskComm(void*)
{

    Serial.begin(9600);                             // Open Serial Monitor

    for(;;)
    {
        Serial.println("The LED is blinking now");
        rtDelay(500);

    }

} // End TaskComm
